# Form implementation generated from reading ui file 'erdcgui.ui'
#
# Created by: PyQt6 UI code generator 6.3.1
#
# WARNING: Any manual changes made to this file will be lost when pyuic6 is
# run again.  Do not edit this file unless you know what you are doing.
import os
from backend.elevationreader import ElevationReader
from backend.stwavereader import Reader
from PyQt6 import QtCore, QtGui, QtWidgets
from PyQt6.QtWidgets import QFileDialog, QMessageBox
from backend.stats import *
from pyqtgraph import PlotWidget, plot
import numpy as np

class Ui_MainWindow(object):
    def __init__(self):
        self.firstfile = ""
        self.secondfile = ""
        self.reader1 = ElevationReader("/")
        self.reader2 = ElevationReader("/")

    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(900, 700)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(MainWindow.sizePolicy().hasHeightForWidth())
        MainWindow.setSizePolicy(sizePolicy)
        MainWindow.setMinimumSize(QtCore.QSize(800, 600))
        MainWindow.setMaximumSize(QtCore.QSize(1920, 1080))
        MainWindow.setAutoFillBackground(True)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.tabWidget = QtWidgets.QTabWidget(self.centralwidget)
        self.tabWidget.setGeometry(QtCore.QRect(0, 0, 901, 681))
        palette = QtGui.QPalette()
        brush = QtGui.QBrush(QtGui.QColor(255, 255, 255))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Active, QtGui.QPalette.ColorRole.NoRole, brush)
        brush = QtGui.QBrush(QtGui.QColor(255, 255, 255))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Inactive, QtGui.QPalette.ColorRole.NoRole, brush)
        brush = QtGui.QBrush(QtGui.QColor(255, 255, 255))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Disabled, QtGui.QPalette.ColorRole.NoRole, brush)
        self.tabWidget.setPalette(palette)
        self.tabWidget.setFocusPolicy(QtCore.Qt.FocusPolicy.NoFocus)
        self.tabWidget.setAutoFillBackground(True)
        self.tabWidget.setTabShape(QtWidgets.QTabWidget.TabShape.Rounded)
        self.tabWidget.setElideMode(QtCore.Qt.TextElideMode.ElideRight)
        self.tabWidget.setUsesScrollButtons(False)
        self.tabWidget.setDocumentMode(True)
        self.tabWidget.setTabsClosable(False)
        self.tabWidget.setMovable(False)
        self.tabWidget.setObjectName("tabWidget")
        self.tab = QtWidgets.QWidget()
        self.tab.setObjectName("tab")
        self.frame = QtWidgets.QFrame(self.tab)
        self.frame.setGeometry(QtCore.QRect(440, 0, 461, 661))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.frame.sizePolicy().hasHeightForWidth())
        self.frame.setSizePolicy(sizePolicy)
        self.frame.setAutoFillBackground(True)
        self.frame.setFrameShape(QtWidgets.QFrame.Shape.StyledPanel)
        self.frame.setFrameShadow(QtWidgets.QFrame.Shadow.Raised)
        self.frame.setLineWidth(1)
        self.frame.setObjectName("frame")
        self.groupBox_2 = QtWidgets.QGroupBox(self.frame)
        self.groupBox_2.setGeometry(QtCore.QRect(10, 0, 441, 641))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.groupBox_2.sizePolicy().hasHeightForWidth())
        self.groupBox_2.setSizePolicy(sizePolicy)
        self.groupBox_2.setAutoFillBackground(True)
        self.groupBox_2.setObjectName("groupBox_2")
        self.label_5 = QtWidgets.QLabel(self.groupBox_2)
        self.label_5.setGeometry(QtCore.QRect(40, 190, 101, 20))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_5.sizePolicy().hasHeightForWidth())
        self.label_5.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Helvetica")
        font.setPointSize(18)
        font.setBold(True)
        font.setWeight(75)
        self.label_5.setFont(font)
        self.label_5.setObjectName("label_5")
        self.maxlabel = QtWidgets.QLabel(self.groupBox_2)
        self.maxlabel.setGeometry(QtCore.QRect(150, 190, 191, 21))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.maxlabel.sizePolicy().hasHeightForWidth())
        self.maxlabel.setSizePolicy(sizePolicy)
        self.maxlabel.setFocusPolicy(QtCore.Qt.FocusPolicy.NoFocus)
        self.maxlabel.setAutoFillBackground(False)
        self.maxlabel.setStyleSheet("background-color: white")
        self.maxlabel.setFrameShape(QtWidgets.QFrame.Shape.WinPanel)
        self.maxlabel.setFrameShadow(QtWidgets.QFrame.Shadow.Plain)
        self.maxlabel.setText("")
        self.maxlabel.setObjectName("maxlabel")
        self.label_6 = QtWidgets.QLabel(self.groupBox_2)
        self.label_6.setGeometry(QtCore.QRect(40, 240, 101, 20))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_6.sizePolicy().hasHeightForWidth())
        self.label_6.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Helvetica")
        font.setPointSize(18)
        font.setBold(True)
        font.setItalic(False)
        font.setWeight(75)
        self.label_6.setFont(font)
        self.label_6.setObjectName("label_6")
        self.minlabel = QtWidgets.QLabel(self.groupBox_2)
        self.minlabel.setGeometry(QtCore.QRect(150, 240, 191, 21))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Preferred,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.minlabel.sizePolicy().hasHeightForWidth())
        self.minlabel.setSizePolicy(sizePolicy)
        self.minlabel.setAutoFillBackground(False)
        self.minlabel.setStyleSheet("background-color: white")
        self.minlabel.setFrameShape(QtWidgets.QFrame.Shape.WinPanel)
        self.minlabel.setText("")
        self.minlabel.setObjectName("minlabel")
        self.label_7 = QtWidgets.QLabel(self.groupBox_2)
        self.label_7.setGeometry(QtCore.QRect(40, 290, 101, 20))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_7.sizePolicy().hasHeightForWidth())
        self.label_7.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Helvetica")
        font.setPointSize(18)
        font.setBold(True)
        font.setWeight(75)
        self.label_7.setFont(font)
        self.label_7.setObjectName("label_7")
        self.meanlabel = QtWidgets.QLabel(self.groupBox_2)
        self.meanlabel.setGeometry(QtCore.QRect(150, 290, 191, 21))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Preferred,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.meanlabel.sizePolicy().hasHeightForWidth())
        self.meanlabel.setSizePolicy(sizePolicy)
        self.meanlabel.setAutoFillBackground(False)
        self.meanlabel.setStyleSheet("background-color: white")
        self.meanlabel.setFrameShape(QtWidgets.QFrame.Shape.WinPanel)
        self.meanlabel.setText("")
        self.meanlabel.setObjectName("meanlabel")
        self.label_11 = QtWidgets.QLabel(self.groupBox_2)
        self.label_11.setGeometry(QtCore.QRect(10, 430, 141, 20))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_11.sizePolicy().hasHeightForWidth())
        self.label_11.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Helvetica")
        font.setPointSize(14)
        font.setBold(True)
        font.setWeight(75)
        self.label_11.setFont(font)
        self.label_11.setObjectName("label_11")
        self.label_12 = QtWidgets.QLabel(self.groupBox_2)
        self.label_12.setGeometry(QtCore.QRect(10, 480, 141, 20))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_12.sizePolicy().hasHeightForWidth())
        self.label_12.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Helvetica")
        font.setPointSize(14)
        font.setBold(True)
        font.setWeight(75)
        self.label_12.setFont(font)
        self.label_12.setObjectName("label_12")
        self.label_13 = QtWidgets.QLabel(self.groupBox_2)
        self.label_13.setGeometry(QtCore.QRect(10, 530, 141, 20))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_13.sizePolicy().hasHeightForWidth())
        self.label_13.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Helvetica")
        font.setPointSize(14)
        font.setBold(True)
        font.setWeight(75)
        self.label_13.setFont(font)
        self.label_13.setObjectName("label_13")
        self.absmaxlabel = QtWidgets.QLabel(self.groupBox_2)
        self.absmaxlabel.setGeometry(QtCore.QRect(150, 430, 191, 21))
        self.absmaxlabel.setAutoFillBackground(False)
        self.absmaxlabel.setStyleSheet("background-color: white")
        self.absmaxlabel.setFrameShape(QtWidgets.QFrame.Shape.WinPanel)
        self.absmaxlabel.setText("")
        self.absmaxlabel.setObjectName("absmaxlabel")
        self.absminlabel = QtWidgets.QLabel(self.groupBox_2)
        self.absminlabel.setGeometry(QtCore.QRect(150, 480, 191, 21))
        self.absminlabel.setAutoFillBackground(False)
        self.absminlabel.setStyleSheet("background-color: white")
        self.absminlabel.setFrameShape(QtWidgets.QFrame.Shape.WinPanel)
        self.absminlabel.setText("")
        self.absminlabel.setObjectName("absminlabel")
        self.absmeanlabel = QtWidgets.QLabel(self.groupBox_2)
        self.absmeanlabel.setGeometry(QtCore.QRect(150, 530, 191, 21))
        self.absmeanlabel.setAutoFillBackground(False)
        self.absmeanlabel.setStyleSheet("background-color: white")
        self.absmeanlabel.setFrameShape(QtWidgets.QFrame.Shape.WinPanel)
        self.absmeanlabel.setText("")
        self.absmeanlabel.setObjectName("absmeanlabel")
        self.line = QtWidgets.QFrame(self.groupBox_2)
        self.line.setGeometry(QtCore.QRect(0, 370, 441, 16))
        self.line.setFrameShadow(QtWidgets.QFrame.Shadow.Plain)
        self.line.setFrameShape(QtWidgets.QFrame.Shape.HLine)
        self.line.setObjectName("line")
        self.label_4 = QtWidgets.QLabel(self.groupBox_2)
        self.label_4.setGeometry(QtCore.QRect(0, 20, 441, 111))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_4.sizePolicy().hasHeightForWidth())
        self.label_4.setSizePolicy(sizePolicy)
        self.label_4.setText("")
        self.label_4.setPixmap(QtGui.QPixmap(
            "/Users/kelvinestradasoto/git/surfaceelevationfilereader/frontend/resources"
            "/ERDC_Graphic_Breakdown_CHL_Lab_Graphic-Color_7_1-removebgnew_1_361x150_350x120.png"))
        self.label_4.setScaledContents(True)
        self.label_4.setObjectName("label_4")
        self.pushButton_3 = QtWidgets.QPushButton(self.groupBox_2)
        self.pushButton_3.setEnabled(True)
        self.pushButton_3.setGeometry(QtCore.QRect(370, 600, 61, 32))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.pushButton_3.sizePolicy().hasHeightForWidth())
        self.pushButton_3.setSizePolicy(sizePolicy)
        self.pushButton_3.setMouseTracking(False)
        self.pushButton_3.setFocusPolicy(QtCore.Qt.FocusPolicy.NoFocus)
        self.pushButton_3.setContextMenuPolicy(QtCore.Qt.ContextMenuPolicy.NoContextMenu)
        self.pushButton_3.setToolTipDuration(0)
        self.pushButton_3.setShortcut("")
        self.pushButton_3.setAutoDefault(False)
        self.pushButton_3.setDefault(False)
        self.pushButton_3.setFlat(False)
        self.pushButton_3.setObjectName("pushButton_3")
        self.frame_2 = QtWidgets.QFrame(self.tab)
        self.frame_2.setGeometry(QtCore.QRect(0, 0, 441, 661))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.frame_2.sizePolicy().hasHeightForWidth())
        self.frame_2.setSizePolicy(sizePolicy)
        self.frame_2.setToolTip("")
        self.frame_2.setToolTipDuration(0)
        self.frame_2.setAutoFillBackground(True)
        self.frame_2.setFrameShape(QtWidgets.QFrame.Shape.StyledPanel)
        self.frame_2.setFrameShadow(QtWidgets.QFrame.Shadow.Raised)
        self.frame_2.setObjectName("frame_2")
        self.groupBox = QtWidgets.QGroupBox(self.frame_2)
        self.groupBox.setGeometry(QtCore.QRect(10, 280, 421, 361))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.groupBox.sizePolicy().hasHeightForWidth())
        self.groupBox.setSizePolicy(sizePolicy)
        self.groupBox.setAutoFillBackground(True)
        self.groupBox.setObjectName("groupBox")
        self.textBrowser = QtWidgets.QTextBrowser(self.groupBox)
        self.textBrowser.setGeometry(QtCore.QRect(140, 150, 271, 31))
        self.textBrowser.setStatusTip("")
        self.textBrowser.setLineWrapMode(QtWidgets.QTextEdit.LineWrapMode.NoWrap)
        self.textBrowser.setOpenLinks(False)
        self.textBrowser.setObjectName("textBrowser")
        self.pushButton = QtWidgets.QPushButton(self.groupBox)
        self.pushButton.setGeometry(QtCore.QRect(20, 150, 101, 31))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.pushButton.sizePolicy().hasHeightForWidth())
        self.pushButton.setSizePolicy(sizePolicy)
        self.pushButton.setCheckable(False)
        self.pushButton.setDefault(False)
        self.pushButton.setFlat(False)
        self.pushButton.setObjectName("pushButton")
        self.pushButton_2 = QtWidgets.QPushButton(self.groupBox)
        self.pushButton_2.setGeometry(QtCore.QRect(280, 200, 111, 31))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.pushButton_2.sizePolicy().hasHeightForWidth())
        self.pushButton_2.setSizePolicy(sizePolicy)
        self.pushButton_2.setObjectName("pushButton_2")
        self.label = QtWidgets.QLabel(self.groupBox)
        self.label.setGeometry(QtCore.QRect(10, 30, 91, 21))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label.sizePolicy().hasHeightForWidth())
        self.label.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Lucida Grande")
        font.setPointSize(14)
        font.setBold(True)
        font.setWeight(75)
        self.label.setFont(font)
        self.label.setObjectName("label")
        self.label_18 = QtWidgets.QLabel(self.groupBox)
        self.label_18.setGeometry(QtCore.QRect(350, 300, 61, 51))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_18.sizePolicy().hasHeightForWidth())
        self.label_18.setSizePolicy(sizePolicy)
        self.label_18.setText("")
        self.label_18.setPixmap(
            QtGui.QPixmap("/Users/kelvinestradasoto/git/surfaceelevationfilereader/frontend/resources/USACE_logo.png"))
        self.label_18.setScaledContents(True)
        self.label_18.setObjectName("label_18")
        self.adcircfiles = QtWidgets.QComboBox(self.groupBox)
        self.adcircfiles.setGeometry(QtCore.QRect(140, 60, 191, 21))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.adcircfiles.sizePolicy().hasHeightForWidth())
        self.adcircfiles.setSizePolicy(sizePolicy)
        self.adcircfiles.setObjectName("adcircfiles")
        self.stwavefiles = QtWidgets.QComboBox(self.groupBox)
        self.stwavefiles.setGeometry(QtCore.QRect(140, 90, 191, 21))
        self.stwavefiles.setObjectName("stwavefiles")
        self.adcircradiobtn = QtWidgets.QRadioButton(self.groupBox)
        self.adcircradiobtn.setGeometry(QtCore.QRect(30, 60, 111, 20))
        self.adcircradiobtn.setObjectName("adcircradiobtn")
        self.stwaveradiotbn = QtWidgets.QRadioButton(self.groupBox)
        self.stwaveradiotbn.setGeometry(QtCore.QRect(30, 90, 111, 20))
        self.stwaveradiotbn.setObjectName("stwaveradiotbn")
        self.groupBox_3 = QtWidgets.QGroupBox(self.frame_2)
        self.groupBox_3.setGeometry(QtCore.QRect(10, 0, 421, 281))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.groupBox_3.sizePolicy().hasHeightForWidth())
        self.groupBox_3.setSizePolicy(sizePolicy)
        palette = QtGui.QPalette()
        brush = QtGui.QBrush(QtGui.QColor(0, 255, 0))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Active, QtGui.QPalette.ColorRole.Link, brush)
        brush = QtGui.QBrush(QtGui.QColor(0, 255, 0))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Inactive, QtGui.QPalette.ColorRole.Link, brush)
        brush = QtGui.QBrush(QtGui.QColor(0, 255, 0))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Disabled, QtGui.QPalette.ColorRole.Link, brush)
        self.groupBox_3.setPalette(palette)
        self.groupBox_3.setObjectName("groupBox_3")
        self.label_2 = QtWidgets.QLabel(self.groupBox_3)
        self.label_2.setGeometry(QtCore.QRect(20, 30, 371, 231))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Expanding,
                                           QtWidgets.QSizePolicy.Policy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_2.sizePolicy().hasHeightForWidth())
        self.label_2.setSizePolicy(sizePolicy)
        palette = QtGui.QPalette()
        brush = QtGui.QBrush(QtGui.QColor(0, 161, 251))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Active, QtGui.QPalette.ColorRole.Link, brush)
        brush = QtGui.QBrush(QtGui.QColor(0, 161, 251))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Inactive, QtGui.QPalette.ColorRole.Link, brush)
        brush = QtGui.QBrush(QtGui.QColor(0, 161, 251))
        brush.setStyle(QtCore.Qt.BrushStyle.SolidPattern)
        palette.setBrush(QtGui.QPalette.ColorGroup.Disabled, QtGui.QPalette.ColorRole.Link, brush)
        self.label_2.setPalette(palette)
        self.label_2.setTextFormat(QtCore.Qt.TextFormat.AutoText)
        self.label_2.setScaledContents(True)
        self.label_2.setAlignment(
            QtCore.Qt.AlignmentFlag.AlignLeading | QtCore.Qt.AlignmentFlag.AlignLeft | QtCore.Qt.AlignmentFlag.AlignTop)
        self.label_2.setWordWrap(True)
        self.label_2.setOpenExternalLinks(True)
        self.label_2.setObjectName("label_2")
        self.tabWidget.addTab(self.tab, "")
        self.widget = QtWidgets.QWidget()
        self.widget.setObjectName("widget")
        self.graphicsView = PlotWidget(self.widget)
        self.graphicsView.setGeometry(QtCore.QRect(10, 50, 421, 311))
        self.graphicsView.setObjectName("graphicsView")
        self.label_17 = QtWidgets.QLabel(self.widget)
        self.label_17.setGeometry(QtCore.QRect(10, 20, 421, 21))
        font = QtGui.QFont()
        font.setFamily("Lucida Grande")
        font.setPointSize(18)
        self.label_17.setFont(font)
        self.label_17.setMouseTracking(False)
        self.label_17.setText("File 1 Plot")
        self.label_17.setTextFormat(QtCore.Qt.TextFormat.AutoText)
        self.label_17.setAlignment(QtCore.Qt.AlignmentFlag.AlignCenter)
        self.label_17.setWordWrap(False)
        self.label_17.setObjectName("label_17")
        self.groupBox_4 = QtWidgets.QGroupBox(self.widget)
        self.groupBox_4.setGeometry(QtCore.QRect(10, 360, 421, 281))
        self.groupBox_4.setAutoFillBackground(True)
        self.groupBox_4.setObjectName("groupBox_4")
        self.nodevselevationbtn = QtWidgets.QRadioButton(self.groupBox_4)
        self.nodevselevationbtn.setGeometry(QtCore.QRect(20, 70, 181, 21))
        self.nodevselevationbtn.setObjectName("nodevselevationbtn")
        self.timevselevationbtn = QtWidgets.QRadioButton(self.groupBox_4)
        self.timevselevationbtn.setGeometry(QtCore.QRect(230, 70, 181, 21))
        self.timevselevationbtn.setObjectName("timevselevationbtn")
        self.label_19 = QtWidgets.QLabel(self.groupBox_4)
        self.label_19.setGeometry(QtCore.QRect(20, 110, 161, 21))
        self.label_19.setObjectName("label_19")
        self.label_20 = QtWidgets.QLabel(self.groupBox_4)
        self.label_20.setGeometry(QtCore.QRect(20, 170, 191, 21))
        self.label_20.setObjectName("label_20")
        self.comboBox = QtWidgets.QComboBox(self.groupBox_4)
        self.comboBox.setGeometry(QtCore.QRect(200, 170, 91, 21))
        self.comboBox.setObjectName("comboBox")
        self.comboBox_2 = QtWidgets.QComboBox(self.groupBox_4)
        self.comboBox_2.setGeometry(QtCore.QRect(200, 110, 91, 21))
        self.comboBox_2.setObjectName("comboBox_2")
        self.pushButton_5 = QtWidgets.QPushButton(self.groupBox_4)
        self.pushButton_5.setGeometry(QtCore.QRect(0, 240, 113, 32))
        self.pushButton_5.setObjectName("pushButton_5")
        self.clearplot1btn = QtWidgets.QPushButton(self.groupBox_4)
        self.clearplot1btn.setGeometry(QtCore.QRect(300, 240, 113, 32))
        self.clearplot1btn.setStyleSheet("")
        self.clearplot1btn.setObjectName("clearplot1btn")
        self.label_3 = QtWidgets.QLabel(self.groupBox_4)
        self.label_3.setGeometry(QtCore.QRect(10, 30, 351, 31))
        self.label_3.setObjectName("label_3")
        self.graphicsView_2 = PlotWidget(self.widget)
        self.graphicsView_2.setGeometry(QtCore.QRect(440, 50, 451, 311))
        self.graphicsView_2.setAutoFillBackground(True)
        self.graphicsView_2.setObjectName("graphicsView_2")
        self.label_21 = QtWidgets.QLabel(self.widget)
        self.label_21.setGeometry(QtCore.QRect(440, 20, 451, 21))
        font = QtGui.QFont()
        font.setFamily("Lucida Grande")
        font.setPointSize(18)
        self.label_21.setFont(font)
        self.label_21.setMouseTracking(False)
        self.label_21.setText("File 2 Plot")
        self.label_21.setTextFormat(QtCore.Qt.TextFormat.AutoText)
        self.label_21.setAlignment(QtCore.Qt.AlignmentFlag.AlignCenter)
        self.label_21.setWordWrap(False)
        self.label_21.setObjectName("label_21")
        self.groupBox_5 = QtWidgets.QGroupBox(self.widget)
        self.groupBox_5.setGeometry(QtCore.QRect(440, 360, 451, 281))
        self.groupBox_5.setAutoFillBackground(True)
        self.groupBox_5.setObjectName("groupBox_5")
        self.nodevselevationbtn_2 = QtWidgets.QRadioButton(self.groupBox_5)
        self.nodevselevationbtn_2.setGeometry(QtCore.QRect(30, 70, 181, 21))
        self.nodevselevationbtn_2.setObjectName("nodevselevationbtn_2")
        self.timevselevationbtn_2 = QtWidgets.QRadioButton(self.groupBox_5)
        self.timevselevationbtn_2.setGeometry(QtCore.QRect(240, 70, 181, 21))
        self.timevselevationbtn_2.setObjectName("timevselevationbtn_2")
        self.label_22 = QtWidgets.QLabel(self.groupBox_5)
        self.label_22.setGeometry(QtCore.QRect(20, 110, 161, 21))
        self.label_22.setObjectName("label_22")
        self.label_23 = QtWidgets.QLabel(self.groupBox_5)
        self.label_23.setGeometry(QtCore.QRect(20, 170, 191, 21))
        self.label_23.setObjectName("label_23")
        self.comboBox_3 = QtWidgets.QComboBox(self.groupBox_5)
        self.comboBox_3.setGeometry(QtCore.QRect(200, 170, 91, 21))
        self.comboBox_3.setObjectName("comboBox_3")
        self.comboBox_4 = QtWidgets.QComboBox(self.groupBox_5)
        self.comboBox_4.setGeometry(QtCore.QRect(200, 110, 91, 21))
        self.comboBox_4.setObjectName("comboBox_4")
        self.pushButton_6 = QtWidgets.QPushButton(self.groupBox_5)
        self.pushButton_6.setGeometry(QtCore.QRect(10, 240, 113, 32))
        self.pushButton_6.setObjectName("pushButton_6")
        self.clearplot2btn = QtWidgets.QPushButton(self.groupBox_5)
        self.clearplot2btn.setGeometry(QtCore.QRect(330, 240, 113, 32))
        self.clearplot2btn.setObjectName("clearplot2btn")
        self.label_8 = QtWidgets.QLabel(self.groupBox_5)
        self.label_8.setGeometry(QtCore.QRect(10, 30, 351, 31))
        self.label_8.setObjectName("label_8")
        self.tabWidget.addTab(self.widget, "")
        self.tab_2 = QtWidgets.QWidget()
        self.tab_2.setObjectName("tab_2")
        self.graphicsView_3 = QtWidgets.QGraphicsView(self.tab_2)
        self.graphicsView_3.setGeometry(QtCore.QRect(10, 50, 421, 311))
        self.graphicsView_3.setObjectName("graphicsView_3")
        self.graphicsView_4 = QtWidgets.QGraphicsView(self.tab_2)
        self.graphicsView_4.setGeometry(QtCore.QRect(440, 50, 451, 311))
        self.graphicsView_4.setObjectName("graphicsView_4")
        self.label_24 = QtWidgets.QLabel(self.tab_2)
        self.label_24.setGeometry(QtCore.QRect(10, 20, 421, 21))
        font = QtGui.QFont()
        font.setFamily("Lucida Grande")
        font.setPointSize(18)
        self.label_24.setFont(font)
        self.label_24.setMouseTracking(False)
        self.label_24.setText("File 1 Plot")
        self.label_24.setTextFormat(QtCore.Qt.TextFormat.AutoText)
        self.label_24.setAlignment(QtCore.Qt.AlignmentFlag.AlignCenter)
        self.label_24.setWordWrap(False)
        self.label_24.setObjectName("label_24")
        self.label_25 = QtWidgets.QLabel(self.tab_2)
        self.label_25.setGeometry(QtCore.QRect(440, 20, 451, 21))
        font = QtGui.QFont()
        font.setFamily("Lucida Grande")
        font.setPointSize(18)
        self.label_25.setFont(font)
        self.label_25.setMouseTracking(False)
        self.label_25.setText("File 2 Plot")
        self.label_25.setTextFormat(QtCore.Qt.TextFormat.AutoText)
        self.label_25.setAlignment(QtCore.Qt.AlignmentFlag.AlignCenter)
        self.label_25.setWordWrap(False)
        self.label_25.setObjectName("label_25")
        self.groupBox_6 = QtWidgets.QGroupBox(self.tab_2)
        self.groupBox_6.setGeometry(QtCore.QRect(10, 360, 421, 291))
        self.groupBox_6.setAutoFillBackground(True)
        self.groupBox_6.setObjectName("groupBox_6")
        self.nodevselevationbtn_3 = QtWidgets.QRadioButton(self.groupBox_6)
        self.nodevselevationbtn_3.setGeometry(QtCore.QRect(0, 30, 181, 21))
        self.nodevselevationbtn_3.setObjectName("nodevselevationbtn_3")
        self.pushButton_7 = QtWidgets.QPushButton(self.groupBox_6)
        self.pushButton_7.setGeometry(QtCore.QRect(20, 130, 113, 32))
        self.pushButton_7.setObjectName("pushButton_7")
        self.clearplot1btn_2 = QtWidgets.QPushButton(self.groupBox_6)
        self.clearplot1btn_2.setGeometry(QtCore.QRect(140, 130, 113, 32))
        self.clearplot1btn_2.setObjectName("clearplot1btn_2")
        self.groupBox_7 = QtWidgets.QGroupBox(self.tab_2)
        self.groupBox_7.setGeometry(QtCore.QRect(440, 360, 451, 291))
        self.groupBox_7.setAutoFillBackground(True)
        self.groupBox_7.setObjectName("groupBox_7")
        self.nodevselevationbtn_4 = QtWidgets.QRadioButton(self.groupBox_7)
        self.nodevselevationbtn_4.setGeometry(QtCore.QRect(0, 30, 181, 21))
        self.nodevselevationbtn_4.setObjectName("nodevselevationbtn_4")
        self.pushButton_8 = QtWidgets.QPushButton(self.groupBox_7)
        self.pushButton_8.setGeometry(QtCore.QRect(20, 130, 113, 32))
        self.pushButton_8.setObjectName("pushButton_8")
        self.clearplot1btn_3 = QtWidgets.QPushButton(self.groupBox_7)
        self.clearplot1btn_3.setGeometry(QtCore.QRect(140, 130, 113, 32))
        self.clearplot1btn_3.setObjectName("clearplot1btn_3")
        self.tabWidget.addTab(self.tab_2, "")
        MainWindow.setCentralWidget(self.centralwidget)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        self.tabWidget.setCurrentIndex(0)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "Data Analysis"))
        self.tabWidget.setToolTip(_translate("MainWindow", "<html><head/><body><p><br/></p></body></html>"))
        self.tabWidget.setWhatsThis(
            _translate("MainWindow", "<html><head/><body><p>File Comparison</p><p><br/></p></body></html>"))
        self.groupBox_2.setTitle(_translate("MainWindow", "Results"))
        self.label_5.setText(_translate("MainWindow", "Maximum: "))
        self.label_6.setText(_translate("MainWindow", "Minimum:"))
        self.label_7.setText(_translate("MainWindow", "Mean:"))
        self.label_11.setText(_translate("MainWindow", "Absolute Maximum:"))
        self.label_12.setText(_translate("MainWindow", "Absolute Minimum:"))
        self.label_13.setText(_translate("MainWindow", "Absolute Mean:"))
        self.pushButton_3.setText(_translate("MainWindow", "Help"))
        self.groupBox.setTitle(_translate("MainWindow", "Set-up"))
        self.textBrowser.setPlaceholderText(_translate("MainWindow", "Your files appear here..."))
        self.pushButton.setText(_translate("MainWindow", "Select files"))
        self.pushButton_2.setText(_translate("MainWindow", "Compare data"))
        self.label.setText(_translate("MainWindow", "File type:"))
        self.adcircradiobtn.setText(_translate("MainWindow", "ADCIRC Files:"))
        self.stwaveradiotbn.setText(_translate("MainWindow", "STWAVE Files:"))
        self.groupBox_3.setTitle(_translate("MainWindow", "Description"))
        self.label_2.setText(_translate("MainWindow",
                                        "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
                                        "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
                                        "p, li { white-space: pre-wrap; }\n"
                                        "</style></head><body style=\" font-family:\'.AppleSystemUIFont\'; font-size:13pt; font-weight:400; font-style:normal;\">\n"
                                        "<p style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:14pt;\">This is the results comparison module. This module takes in two files of the same type and reads in all the values in the file. The </span><span style=\" font-size:14pt; font-weight:600; font-style:italic;\">*.63</span><span style=\" font-size:14pt;\"> files represent the surface elevation values at every node for </span><span style=\" font-size:14pt; font-weight:600; font-style:italic;\">x</span><span style=\" font-size:14pt;\"> amount of records. The </span><span style=\" font-size:14pt; font-weight:600; font-style:italic;\">*.64 </span><span style=\" font-size:14pt;\">files represent the depth averaged velocity vectors at every node for </span><span style=\" font-size:14pt; font-weight:600; font-style:italic;\">x </span><span style=\" font-size:14pt;\">amount of records. </span></p>\n"
                                        "<p style=\"-qt-paragraph-type:empty; margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p>\n"
                                        "<p style=\"-qt-paragraph-type:empty; margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-size:14pt;\"><br /></p>\n"
                                        "<p style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:14pt;\">For more information visit: </span><a href=\"https://adcirc.org/home/documentation/users-manual-v53/output-file-descriptions/\"><span style=\" font-size:14pt; text-decoration: underline; color:#0000ff;\">ADCIRC Output Files Description</span></a></p></body></html>"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab), _translate("MainWindow", "Data Comparison"))
        self.groupBox_4.setTitle(_translate("MainWindow", "Plot"))
        self.nodevselevationbtn.setText(_translate("MainWindow", "Node vs Elevation values"))
        self.timevselevationbtn.setText(_translate("MainWindow", "Time vs Elevation values"))
        self.label_19.setText(_translate("MainWindow", "Number of nodes to plot:"))
        self.label_20.setText(_translate("MainWindow", "Number of timesteps to plot:"))
        self.pushButton_5.setText(_translate("MainWindow", "Plot"))
        self.clearplot1btn.setText(_translate("MainWindow", "Clear Plot"))
        self.label_3.setText(_translate("MainWindow", "Select the plot you want to see:"))
        self.groupBox_5.setTitle(_translate("MainWindow", "Plot"))
        self.nodevselevationbtn_2.setText(_translate("MainWindow", "Node vs Elevation values"))
        self.timevselevationbtn_2.setText(_translate("MainWindow", "Time vs Elevation values"))
        self.label_22.setText(_translate("MainWindow", "Number of nodes to plot:"))
        self.label_23.setText(_translate("MainWindow", "Number of timesteps to plot:"))
        self.pushButton_6.setText(_translate("MainWindow", "Plot"))
        self.clearplot2btn.setText(_translate("MainWindow", "Clear Plot"))
        self.label_8.setText(_translate("MainWindow", "Select the plot you want to see:"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.widget), _translate("MainWindow", "ADCIRC Data View"))
        self.groupBox_6.setTitle(_translate("MainWindow", "Select data to plot"))
        self.nodevselevationbtn_3.setText(_translate("MainWindow", "Node vs Elevation values"))
        self.pushButton_7.setText(_translate("MainWindow", "VIEW PLOT"))
        self.clearplot1btn_2.setText(_translate("MainWindow", "CLEAR PLOT"))
        self.groupBox_7.setTitle(_translate("MainWindow", "Select data to plot"))
        self.nodevselevationbtn_4.setText(_translate("MainWindow", "Node vs Elevation values"))
        self.pushButton_8.setText(_translate("MainWindow", "VIEW PLOT"))
        self.clearplot1btn_3.setText(_translate("MainWindow", "CLEAR PLOT"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_2), _translate("MainWindow", "STWAVE Data View"))

        # ---------- Button actions ---------------------------------------------------------
        self.pushButton_2.setEnabled(False)
        self.pushButton.clicked.connect(self.get_file_names)
        self.pushButton_2.clicked.connect(self.process_files)
        self.pushButton_3.clicked.connect(self.results_info_btn4)
        self.adcircradiobtn.toggled.connect(self.enable_adcirc)
        self.stwaveradiotbn.toggled.connect(self.enable_stwave)
        self.pushButton_5.clicked.connect(self.all_values_of_leftbtn)
        self.pushButton_6.clicked.connect(self.all_values_of_rightbtn)
        self.clearplot1btn.clicked.connect(self.clear_plot2)
        self.clearplot2btn.clicked.connect(self.clear_plot1)
        self.nodevselevationbtn.clicked.connect(self.enable_nodevselevation)
        self.nodevselevationbtn_2.clicked.connect(self.enable_nodevselevation2)
        self.timevselevationbtn.clicked.connect(self.enable_timevselevation)
        self.timevselevationbtn_2.clicked.connect(self.enable_timevselevation2)
        # ---------------- populate combo box for adcirc files and stwave files.---------------
        adcirc = ['surface elevation files', 'averaged velocity files']
        for file in adcirc:
            self.adcircfiles.addItem(file)
        stwave = ['spatial data files', 'spectral data files']
        for file in stwave:
            self.stwavefiles.addItem(file)
        # --------------- start the program with ADCIRC selection as default. ---------------
        self.adcircradiobtn.setChecked(True)
        self.stwaveradiotbn.setChecked(False)
        self.adcircfiles.setEnabled(True)
        self.stwavefiles.setEnabled(False)
        # --------------- make Node vs Elevation plot default. ------------------------------
        self.nodevselevationbtn.setChecked(True)
        self.nodevselevationbtn_2.setChecked(True)
        self.comboBox_2.setEnabled(True)
        self.comboBox.setEnabled(False)
        self.comboBox_4.setEnabled(True)
        self.comboBox_3.setEnabled(False)
        # --------------- When starting, combo boxes are disabled ---------------------------
        self.comboBox.setDisabled(True)
        self.comboBox_2.setDisabled(True)
        self.comboBox_3.setDisabled(True)
        self.comboBox_4.setDisabled(True)

    def enable_adcirc(self):
        self.adcircfiles.setEnabled(True)
        self.stwavefiles.setEnabled(False)

    def enable_stwave(self):
        self.stwavefiles.setEnabled(True)
        self.adcircfiles.setEnabled(False)

    def enable_nodevselevation(self):
        self.comboBox_2.setEnabled(True)
        self.comboBox.setEnabled(False)

    def enable_nodevselevation2(self):
        self.comboBox_4.setEnabled(True)
        self.comboBox_3.setEnabled(False)

    def enable_timevselevation(self):
        self.comboBox_2.setEnabled(False)
        self.comboBox.setEnabled(True)

    def enable_timevselevation2(self):
        self.comboBox_4.setEnabled(False)
        self.comboBox_3.setEnabled(True)

    def get_file_names(self):
        """
            Prompts the user to select the files to analyze.
            :return: a list containing the file paths.
        """
        response = [""], ""
        if self.adcircradiobtn.isChecked():
            if self.adcircfiles.currentText() == 'surface elevation files':
                response = QFileDialog.getOpenFileNames(
                    caption='Select file',
                    directory=os.getcwd(),
                    filter="Surface elevation (*.63)"
                )
            if self.adcircfiles.currentText() == 'averaged velocity files':
                response = QFileDialog.getOpenFileNames(
                    caption='Select file',
                    directory=os.getcwd(),
                    filter="Depth-averaged velocity (*.64)"
                )
        else:
            if self.stwavefiles.currentText() == 'spatial data files':
                response = QFileDialog.getOpenFileNames(
                    caption='Select file',
                    directory=os.getcwd(),
                    filter='Spatial files (*.break.out) (*.dep) (*.friction.in) (*.rads.out) (*.Tp.out) (*.wave.out)'
                )
            if self.stwavefiles.currentText() == 'spectral data files':
                response = QFileDialog.getOpenFileNames(
                    caption='Select file',
                    directory=os.getcwd(),
                    filter="Spectral files (*.eng)"
                )
        files = response[0]
        self.textBrowser.clear()
        # Verify user selected two files.
        if len(files) == 2:
            self.pushButton_2.setEnabled(True)
            self.firstfile = files[0]
            self.secondfile = files[1]
            self.textBrowser.append(self.firstfile)
            self.textBrowser.append(self.secondfile)
        # Only one file selected? Tell the user.
        else:
            self.pushButton_2.setEnabled(False)
            msg = QMessageBox()
            msg.setWindowTitle("Missing input file")
            msg.setIcon(QMessageBox.Icon.Critical)
            msg.setText("You have one missing file")
            msg.setInformativeText("Please, select two files of the same type.")
            msg.exec()
        return response

    def process_files(self):
        """
            This function executes the process of reading the files and analyzing the data of each file.
            :return:
        """

        if not self.firstfile or not self.secondfile:
            msg = QMessageBox()
            msg.setWindowTitle("Missing input files")
            msg.setIcon(QMessageBox.Icon.Critical)
            msg.setText("You have missing files")
            msg.setInformativeText("You have no selected files.")
            msg.exec()
        else:
            if self.adcircradiobtn.isChecked():
                self.reader1 = ElevationReader(self.firstfile)
                self.reader2 = ElevationReader(self.secondfile)
                # *.63 files are selected to be read. READ.
                if self.adcircfiles.currentText() == 'surface elevation files':
                    self.reader1.read_file()
                    self.reader2.read_file()
                # *.64 files are selected to be read. READ.
                else:
                    self.reader1.read_file()
                    self.reader2.read_file()

            if self.stwaveradiotbn.isChecked():
                self.streader1 = Reader(self.firstfile)
                self.streader2 = Reader(self.secondfile)
                self.streader1.read_file()
                self.streader2.read_file()

            """ If *.63 file was read then get the surface elevation values without the node number. All records mixed in 
            order. If *.64 file was read then get the <u, v> velocity vector values without the node number. All records 
            mixed in order. """
            values1 = self.reader1.get_surface_elevations_every_node()
            values2 = self.reader2.get_surface_elevations_every_node()

            """ If data collected from the files do not contain the same number of records, pop-up error message. 
            Otherwise, do comparison calculations. """
            if len(values1) != len(values2):
                msg = QMessageBox()
                msg.setWindowTitle("Error!")
                msg.setText("Incompatible datasets.")
                msg.setInformativeText("You should select two files of the same size of datasets.")
                msg.exec()

            else:

                # TODO: Verify if surface elevation values are going to be compared of vector values are going to be
                #   compared.
                results = compare_scalars(values1, values2)
                diff = results[0]

                # Values with negative signs.
                maxdiff = str(diff[0])
                mindiff = str(diff[1])
                meandiff = str(diff[2])

                # Positive values only.
                absdifferences = results[1]
                absmax = str(absdifferences[0])
                absmin = str(absdifferences[1])
                absmean = str(absdifferences[2])

                # Display on screen.
                self.maxlabel.setText(maxdiff)
                self.minlabel.setText(mindiff)
                self.meanlabel.setText(meandiff)
                self.absmaxlabel.setText(absmax)
                self.absminlabel.setText(absmin)
                self.absmeanlabel.setText(absmean)

                self.populate_plot_comboboxes()

    def populate_plot_comboboxes(self):
        # Add timesteps to combo box
        time = self.reader1.get_timesteps_of_every_record()
        for i in range(0, len(time)):
            self.comboBox.addItem(str(time[i]))
            self.comboBox_3.addItem(str(time[i]))

        # Add nodes to combo box
        nodes = self.reader1.read_num_of_nodes()
        for i in range(1, nodes + 1):
            self.comboBox_2.addItem(str(i))
            self.comboBox_4.addItem(str(i))

    def all_values_of_leftbtn(self):
        """
        :param
        :return:
        """
        if self.nodevselevationbtn.isChecked():
            nodenumber = int(self.comboBox_2.currentText())
            valuesfornode = self.reader1.get_all_elevations_for_node(nodenumber)
            numofrecords = self.reader1.read_num_of_records()
            x_first = np.arange(0, numofrecords, 1)  # number of records
            y_first = valuesfornode  # elevation values for first file
            self.graphicsView.plot(x_first, y_first)

        if self.timevselevationbtn.isChecked():
            timestep = int(self.comboBox.currentText())
            valuesfortimestep1 = self.reader1.get_all_elevations_for_time(timestep)
            print(valuesfortimestep1)
            numofnodes = self.reader1.read_num_of_nodes()

            x_second = np.arange(0, numofnodes, 1)
            y_second = valuesfortimestep1  # elevation values for first file
            self.graphicsView.plot(x_second, y_second)

    def all_values_of_rightbtn(self):
        if self.nodevselevationbtn_2.isChecked():
            nodenumber = int(self.comboBox_4.currentText())
            valuesfornode = self.reader2.get_all_elevations_for_node(nodenumber)
            numofrecords = self.reader1.read_num_of_records()
            x = np.arange(0, numofrecords, 1)  # number of records
            y = valuesfornode  # elevation values for first file
            self.graphicsView_2.plot(x, y)
        if self.timevselevationbtn_2.isChecked():
            timestep = int(self.comboBox_3.currentText())
            values = self.reader1.get_all_elevations_for_time(timestep)
            numofnodes = self.reader1.read_num_of_nodes()
            x = np.arange(0, numofnodes, 1)
            y = values  # elevation values for first file
            print(len(x))
            print(y)
            self.graphicsView_2.plot(x, y)

    @staticmethod
    def results_info_btn4():
        msg = QMessageBox()
        msg.setWindowTitle("Difference values")
        msg.setIcon(QMessageBox.Icon.Question)
        msg.setText("What are the results on screen?")
        msg.setInformativeText("- Maximum: this is the maximum value of the differences between the data of file 1 and "
                               "file 2.\n"
                               "\n- Minimum: this is the minimum value of the differences between the data of file 1 "
                               "and file 2.\n"
                               "\n- Mean: this is the average value of the differences between the data of file 1 and "
                               "file 2.\n"
                               "\n- Absolute Maximum: this is absolute the maximum value of the differences between "
                               "the data of file 1 and file 2.\n"
                               "\n- Absolute Minimum: this is the absolute minimum value of the differences between "
                               "the data of file 1 and file 2.\n"
                               "\n- Absolute Mean: this is the absolute average value of the differences between the "
                               "data of file 1 and file 2.")
        msg.exec()

    def clear_plot2(self):
        self.graphicsView_2.clear()

    def clear_plot1(self):
        self.graphicsView.clear()


if __name__ == "__main__":
    import sys

    app = QtWidgets.QApplication(sys.argv)
    MainWindow = QtWidgets.QMainWindow()
    ui = Ui_MainWindow()
    ui.setupUi(MainWindow)
    MainWindow.show()
    sys.exit(app.exec())
